<script setup lang="ts">
import type { HeaderPrep, RefSearchNav } from '~/components/pub/my-ui/data/types'

// #region Imports
import RecordConfirmation from '~/components/pub/my-ui/confirmation/record-confirmation.vue'
import { ActionEvents } from '~/components/pub/my-ui/data/types'

import Header from '~/components/pub/my-ui/nav-header/prep.vue'
import { usePaginatedList } from '~/composables/usePaginatedList'
import { getList, remove } from '~/services/control-letter.service'
import { toast } from '~/components/pub/ui/toast'
import type { Encounter } from '~/models/encounter'
import WarningAlert from '~/components/pub/my-ui/alert/warning-alert.vue'
// import type { PagePermission } from '~/models/role'
import { PAGE_PERMISSIONS } from '~/lib/page-permission'
import { permissions } from '~/const/page-permission/ambulatory'
import { unauthorizedToast } from '~/lib/utils'
import Dialog from '~/components/pub/my-ui/modal/dialog.vue'
import DocPreviewDialog from '~/components/pub/my-ui/modal/doc-preview-dialog.vue'
import HistoryDialog from '~/components/app/control-letter/history-dialog.vue'
import type { RoleAccesses } from '~/models/role'
// #endregion

// #region Permission
const roleAccess: RoleAccesses = permissions['/ambulatory/encounter'] || {}
const { getPagePermissions } = useRBAC()
const pagePermission = getPagePermissions(roleAccess)

// #region State
const props = withDefaults(defineProps<{ 
  encounter_id: number
  redirectToForm?: (myRecord_id?: any) => void
  redirectToDetail?: (myRecord_id: string|number) => void
}>(), {
  redirectToForm: () => { },
  redirectToDetail: () => { }
})

const { data, isLoading, paginationMeta, searchInput, handlePageChange, handleSearch, fetchData } = usePaginatedList({
  fetchFn: (params) => getList({ ...params, includes: 'specialist,subspecialist,doctor-employee-person', }),
  entityName: 'control-letter',
})
const historyData = usePaginatedList({
  fetchFn: (params) => getList({ ...params, includes: ['person', 'person-Addresses'] }),
  entityName: 'control-letter-history',
})

const refSearchNav: RefSearchNav = {
  onClick: () => {
    // open filter modal
  },
  onInput: (val: string) => {
    searchInput.value = val
  },
  onClear: () => {
    searchInput.value = ''
  },
}

const isHistoryDialogOpen = ref(false)
provide('isHistoryDialogOpen', isHistoryDialogOpen)

const isDocPreviewDialogOpen = ref(false)
const isRecordConfirmationOpen = ref(false)
const summaryLoading = ref(false)
const isRequirementsMet = ref(true)

const recId = ref<number>(0)
const recAction = ref<string>('')
const recItem = ref<any>(null)
const timestamp = ref(new Date().toISOString())

const headerPrep: HeaderPrep = {
  title: "Surat Kontrol",
  icon: 'i-lucide-newspaper',
}
if (pagePermission.canCreate) {
  headerPrep.addNav = {
    label: "Surat Kontrol",
    onClick: () => {
      console.log('redirectToForm')
      console.log(props.redirectToForm())
      props.redirectToForm()
    },
  }
}
// #endregion

// #region Lifecycle Hooks
onMounted(() => {
  getListData()
})
// #endregion

// #region Functions
async function getListData() {
  try {
    summaryLoading.value = true
    await new Promise((resolve) => setTimeout(resolve, 500))
  } catch (error) {
    console.error('Error fetching Data:', error)
  } finally {
    summaryLoading.value = false
  }
}

// Handle confirmation result
async function handleConfirmDelete(record: any, action: string) {
  if (action === 'delete' && record?.id) {
    try {
      const result = await remove(record.id)
      if (result.success) {
        toast({ title: 'Berhasil', description: 'Data berhasil dihapus', variant: 'default' })
        await fetchData()
      } else {
        toast({ title: 'Gagal', description: `Data gagal dihapus`, variant: 'destructive' })
      }
    } catch (error) {
      toast({ title: 'Gagal', description: `Something went wrong`, variant: 'destructive' })
    }
  }
}

function handleCancelConfirmation() {
  // Reset record state when cancelled
  recId.value = 0
  recAction.value = ''
  recItem.value = null
}
// #endregion

// #region Provide
provide('rec_id', recId)
provide('rec_action', recAction)
provide('rec_item', recItem)
provide('timestamp', isLoading)
provide('table_data_loader', isLoading)
// #endregion

// #region Watchers
watch([recId, recAction, timestamp], () => {
  switch (recAction.value) {
    case ActionEvents.showDetail:
      props.redirectToDetail(recId.value)
      break

    case ActionEvents.showEdit:
      if(pagePermission.canUpdate){ 
        props.redirectToForm(recId.value)
      } else {
        unauthorizedToast()
      }
      break

    case ActionEvents.showConfirmDelete:
      if(pagePermission.canDelete){
        isRecordConfirmationOpen.value = true
      } else {
        unauthorizedToast()
      }
      break
  }
})
// #endregion
</script>

<template>
  <WarningAlert v-if="!isRequirementsMet"
    class="mb-5"
    text="Syarat pembuatan surat kontrol belum terpenuhi"
    :description="[
      'Lanjutan Penatalaksanaan Pasien harus pulang/KRS.',
      'Status Resume Medis harus tervalidasi.'
    ]" />

  <div v-else>
    <Header v-model:search="searchInput"
      :prep="{ ...headerPrep }"
      :ref-search-nav="refSearchNav"
      @search="handleSearch" />

    <div class="mb-3 flex justify-end items-center">
      <Button variant="outline"
        class="gap-1 bg-transparent items-center text-orange-400 border-orange-400"
        @click="isHistoryDialogOpen = true">
        <Icon name="i-lucide-history" class="h-4 w-4" /> Riwayat Program Nasional</Button>
    </div>
    
    <AppControlLetterList :data="data" :pagination-meta="paginationMeta" @page-change="handlePageChange" />

    <Dialog v-model:open="isDocPreviewDialogOpen" title="Preview Dokumen" size="2xl">
      <DocPreviewDialog :link="`https://www.antennahouse.com/hubfs/xsl-fo-sample/pdf/basic-link-1.pdf`" />
    </Dialog>

    <RecordConfirmation v-model:open="isRecordConfirmationOpen" action="delete" :record="recItem"
      @confirm="handleConfirmDelete" @cancel="handleCancelConfirmation">
      <template #default="{ record }">
        <div class="text-sm">
          <p>
            <strong>ID:</strong>
            {{ record?.id }}
          </p>
          <p v-if="record?.firstName">
            <strong>Nama:</strong>
            {{ record.firstName }}
          </p>
          <p v-if="record?.code">
            <strong>Kode:</strong>
            {{ record.cellphone }}
          </p>
        </div>
      </template>
    </RecordConfirmation>
    
      <HistoryDialog
        v-model:is-modal-open="isHistoryDialogOpen"
        :data="historyData.data.value"
        :pagination-meta="historyData.paginationMeta"
        @page-change="historyData.handlePageChange"
      />

  </div>
</template>
